"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  PolkadotDappProvider: () => PolkadotDappProvider,
  useChain: () => useChain,
  usePolkadotDapp: () => usePolkadotDapp,
  useWallet: () => useWallet
});
module.exports = __toCommonJS(src_exports);

// src/react.tsx
var import_react = __toESM(require("react"), 1);
var import_react2 = require("react");
var import_zustand2 = require("zustand");

// src/store/index.ts
var import_zustand = require("zustand");

// src/store/chains.ts
var import_api = require("@polkadot/api");
var createAPISlice = (props) => (set) => {
  const api = {};
  Object.entries(props.chains).forEach(([key, options]) => {
    const chainAPI = new import_api.ApiPromise(options);
    chainAPI.on("error", (e) => {
      console.error("Error on ", key, e);
      set((state) => ({
        error: {
          [key]: Error("TODO decode error"),
          ...state.error
        },
        ready: {
          [key]: false,
          ...state.ready
        }
      }));
    });
    chainAPI.on("disconnected", (e) => {
      console.error("Disconnected on", key, e);
      set((state) => ({
        error: {
          [key]: Error("TODO decode error on console"),
          ...state.error
        },
        connected: {
          [key]: false,
          ...state.connected
        },
        ready: {
          [key]: false,
          ...state.ready
        }
      }));
    });
    chainAPI.on("connected", () => {
      console.info("Connected on", key);
      set((state) => ({
        error: {
          [key]: void 0,
          ...state.error
        },
        connected: {
          [key]: true,
          ...state.connected
        }
      }));
    });
    chainAPI.on("ready", () => {
      console.info("Ready on", key);
      set((state) => ({
        ready: {
          [key]: true,
          ...state.ready
        },
        errors: {
          [key]: void 0,
          ...state.error
        }
      }));
    });
    api[key] = chainAPI;
  });
  return {
    api
  };
};

// src/store/wallet.ts
var import_extension_dapp = require("@polkadot/extension-dapp");
var createWalletSlice = (props) => (set, get) => {
  const connect = async () => {
    set({ isConnecting: true });
    const extensions = await (0, import_extension_dapp.web3Enable)("Polkadot Dapp Template");
    if (extensions.length !== 0) {
      const accounts = await (0, import_extension_dapp.web3Accounts)();
      set({ accounts, isConnected: true });
      return accounts;
    }
    set({ isConnecting: false });
    return [];
  };
  const selectAccount = (address) => {
    set({
      selectedAccount: get().accounts.find((a) => a.address === address)
    });
  };
  if (props.eagerConnect) {
    void connect().then((accounts) => {
      if (accounts[0]) {
        selectAccount(accounts[0].address);
      }
    });
  }
  return {
    accounts: [],
    isConnected: false,
    isConnecting: false,
    selectedAccount: void 0,
    connect,
    selectAccount
  };
};

// src/store/index.ts
var createPolkadotDappStore = (initProps) => {
  const props = {
    eagerConnect: false,
    chains: {},
    ...initProps
  };
  return (0, import_zustand.createStore)()((...a) => ({
    ...createAPISlice(props)(...a),
    ...createWalletSlice(props)(...a)
  }));
};

// src/react.tsx
var PolkadotDappContext = (0, import_react2.createContext)(
  null
);
var PolkadotDappProvider = ({ children, ...props }) => {
  const storeRef = (0, import_react2.useRef)();
  if (!storeRef.current) {
    storeRef.current = createPolkadotDappStore(props);
  }
  return /* @__PURE__ */ import_react.default.createElement(PolkadotDappContext.Provider, { value: storeRef.current }, children);
};
function usePolkadotDapp(selector) {
  const store = (0, import_react2.useContext)(PolkadotDappContext);
  if (!store)
    throw new Error("Missing PolkadotDappContext.Provider in the tree");
  return (0, import_zustand2.useStore)(store, selector);
}
var useApi = (chain) => {
  return usePolkadotDapp((state) => state.api[chain]);
};
var useChain = useApi;
var useWallet = () => {
  return usePolkadotDapp((state) => ({
    accounts: state.accounts,
    connect: state.connect,
    isConnected: state.isConnected,
    isConnecting: state.isConnecting,
    selectAccount: state.selectAccount,
    selectedAccount: state.selectedAccount
  }));
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PolkadotDappProvider,
  useChain,
  usePolkadotDapp,
  useWallet
});
//# sourceMappingURL=index.cjs.map