import * as _polkadot_api from '@polkadot/api';
import { ApiPromise } from '@polkadot/api';
import React, { ReactNode } from 'react';
import { ApiOptions } from '@polkadot/api/types';
import { web3Accounts } from '@polkadot/extension-dapp';

type Prettify<T> = {
  [K in keyof T]: T[K];
} & {};

interface APISlice {
    api: Prettify<Record<keyof PolkadotDappProps["chains"], ApiPromise>>;
    error: Prettify<Record<keyof PolkadotDappProps["chains"], Error | undefined>>;
    ready: Prettify<Record<keyof PolkadotDappProps["chains"], boolean>>;
    connected: Prettify<Record<keyof PolkadotDappProps["chains"], boolean>>;
}

type InjectedAccountWithMeta = Awaited<ReturnType<typeof web3Accounts>>[0];
interface WalletSlice {
    accounts: InjectedAccountWithMeta[];
    connect: () => Promise<InjectedAccountWithMeta[]>;
    selectAccount: (address: string) => void;
    isConnecting: boolean;
    isConnected: boolean;
    selectedAccount?: InjectedAccountWithMeta;
}

type PolkadotDappState = APISlice & WalletSlice;

interface PolkadotDappProps {
    eagerConnect: boolean;
    chains: Record<string, ApiOptions>;
}

declare const PolkadotDappProvider: React.FC<PolkadotDappProps & {
    children: ReactNode;
}>;
declare function usePolkadotDapp<T>(selector: (state: PolkadotDappState) => T): T;
/**
 * DEPRECATE, use `useApi` instead`
 */
declare const useChain: (chain: keyof APISlice["api"]) => _polkadot_api.ApiPromise | undefined;
declare const useWallet: () => WalletSlice;

export { PolkadotDappProvider, useChain, usePolkadotDapp, useWallet };
